//
//  ViewController.m
//  Master Neurosurgeon
//
//  Created by Mina khosravifard on 1/7/14.
//  Copyright (c) 2014 Mina khosravifard. All rights reserved.
//

#import "ViewController.h"
#import "PatientCase.h"
#import <CoreData/CoreData.h>
#import "AppDelegate.h"
#import "PatiantTBLViewController.h"
#import "PatiantTBLViewController.h"
#import "CustomLoginViewController.h"


@interface ViewController ()
{
    CGPoint lastPoint;
    CGFloat red;
    CGFloat green;
    CGFloat blue;
    CGFloat brush;
    CGFloat opacity;
    BOOL mouseSwiped;
    BOOL toggledraw;
    BOOL musicisplayed;
    NSString *path;
    NSError *error;
    NSMutableArray *patientMD;
    NSMutableArray *patientMD1;
    NSMutableArray *erasepoints;
    NSMutableArray *firstpoints;
    NSInteger id;
    float score;
    float average;
}
@end

@implementation ViewController
@synthesize patientImageNameforNextView;
@synthesize eraserflag;
@synthesize drawingflag;
@synthesize userkind;
@synthesize scroller;
@synthesize music;
@synthesize panbutton;
@synthesize savebutton;



-(void)viewWillAppear:(BOOL)animated
{
    self.navigationController.navigationBar.hidden=true;   //works....
}

#pragma mark - Drawing fucntion
- (void)viewDidLoad
{
    [super viewDidLoad];
	
    AppDelegate *appdelegate=[[UIApplication sharedApplication]delegate];
    _managedObjectContext=[appdelegate managedObjectContext];
    
    //set the image of patinet case
    self.templayer.image=[UIImage imageNamed:patientImageNameforNextView];

    //set the defult color for pencil
    red = 255.0/255.0;
    green = 0.0/255.0;
    blue = 0.0/255.0;
    drawingflag=false;
    
    //set brush size and earser statue
    brush = 1.0;
    eraserflag=false;
    
    //allocate space to matadata array
    patientMD=[[NSMutableArray alloc]init];
    
    //set music statues
    musicisplayed=false;
    
    //check user type
    CustomLoginViewController *cvc=[[CustomLoginViewController alloc]init];
    userkind=cvc.selectedtype;
    if ([userkind isEqual:@"1"]) {
        self.savebutton.hidden=NO;
    } else {
        self.savebutton.hidden=YES;
    
    }
    }

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


-(void)viewDidLayoutSubviews
{
    
    scroller.scrollEnabled=YES;
    scroller.contentSize=self.mainlayer.frame.size;
    toggledraw=false;
    
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    if (eraserflag) {
         self.mainlayer.image=[UIImage imageNamed:patientImageNameforNextView];
    }
    //set the pen color to red
    red = 255.0/255.0;
    green = 0.0/255.0;
    blue = 0.0/255.0;

    if (drawingflag) {
        
        //initial setting for touch point
        mouseSwiped = NO;
        UITouch *touch = [touches anyObject];
        lastPoint = [touch locationInView:self.templayer];
        
        //add the drawing point to  draw set
        if (!eraserflag) {
            [firstpoints addObject:[NSValue valueWithCGPoint:lastPoint]];
            [patientMD addObject:[NSValue valueWithCGPoint:lastPoint]];
        }
        else
        //add erasing point to erase set
        {
            [erasepoints addObject:[NSValue valueWithCGPoint:lastPoint]];
            [self improvedErase:lastPoint];
        }
        [self drawingmusic];
    }
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
    if (drawingflag) {
        //initial setting for touch point
        mouseSwiped = YES;
        UITouch *touch = [touches anyObject];
        CGPoint currentPoint = [touch locationInView:self.templayer];
        
       //add the drawing point to  draw set
        if (!eraserflag) {
            [patientMD addObject:[NSValue valueWithCGPoint:currentPoint]];
            //NSLog(@"meta point%@", NSStringFromCGPoint(currentPoint));
            
        }
        else
        {
            [erasepoints addObject:[NSValue valueWithCGPoint:currentPoint]];
            [self improvedErase:currentPoint];
            //NSLog(@"erase point %@", NSStringFromCGPoint(currentPoint));
        }
        
        //set the concext
        UIGraphicsBeginImageContext(self.templayer.frame.size);
        [self.templayer.image drawInRect:CGRectMake(0, 0, self.templayer.frame.size.width, self.templayer.frame.size.height)];
        CGContextMoveToPoint(UIGraphicsGetCurrentContext(), lastPoint.x, lastPoint.y);
        
        //add master surgeon points to array
        if (!eraserflag) {
            [patientMD addObject:[NSValue valueWithCGPoint:lastPoint]];
            //print point
             //NSLog(@"meta point %@", NSStringFromCGPoint(lastPoint));
        }
        else
        {
            [erasepoints addObject:[NSValue valueWithCGPoint:lastPoint]];
            [self improvedErase:lastPoint];
            //NSLog(@"erase point %@", NSStringFromCGPoint(lastPoint));
        }
        
        
        
        CGContextAddLineToPoint(UIGraphicsGetCurrentContext(), currentPoint.x, currentPoint.y);
        
         //add the drawing point to  draw set
        if (!eraserflag) {
            [patientMD addObject:[NSValue valueWithCGPoint:currentPoint]];
        }else
        {
            [erasepoints addObject:[NSValue valueWithCGPoint:lastPoint]];
            [self improvedErase:lastPoint];
        }
        
        //drawing setting
        CGContextSetLineCap(UIGraphicsGetCurrentContext(), kCGLineCapRound);
        CGContextSetLineWidth(UIGraphicsGetCurrentContext(), 1);
        
        //consider earsing
        if (eraserflag) {
            CGContextSetBlendMode(UIGraphicsGetCurrentContext(), kCGBlendModeClear);
            CGContextSetLineWidth(UIGraphicsGetCurrentContext(), 5);
            
        } else {
            CGContextSetRGBStrokeColor(UIGraphicsGetCurrentContext(),red, green, blue, 1);
            CGContextSetLineWidth(UIGraphicsGetCurrentContext(), 1);
            
            CGContextSetBlendMode(UIGraphicsGetCurrentContext(),kCGBlendModeNormal);
        }
        
        
        CGContextStrokePath(UIGraphicsGetCurrentContext());
        self.templayer .image = UIGraphicsGetImageFromCurrentImageContext();
        UIGraphicsEndImageContext();
        //add the drawing point to  draw set
        lastPoint = currentPoint;
        if (!eraserflag) {
        }
        [self drawingmusic];
    }
}
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
    if (drawingflag) {
        if (player1 != nil)
        {
            if (player1.isPlaying == YES)
                [player1 stop];
        }
        if(!mouseSwiped) {
            
            //initial seting
            UIGraphicsBeginImageContext(self.templayer.frame.size);
            [self.templayer.image drawInRect:CGRectMake(0, 0, self.templayer.frame.size.width, self.templayer.frame.size.height)];
            CGContextSetLineCap(UIGraphicsGetCurrentContext(), kCGLineCapRound);
            CGContextSetLineWidth(UIGraphicsGetCurrentContext(), brush);
            CGContextSetRGBStrokeColor(UIGraphicsGetCurrentContext(), red, green, blue, opacity);
            CGContextMoveToPoint(UIGraphicsGetCurrentContext(), lastPoint.x, lastPoint.y);
            
           //add the drawing point to  draw set
            if (!eraserflag) {
                [patientMD addObject:[NSValue valueWithCGPoint:lastPoint]];
            }else
            {
                [erasepoints addObject:[NSValue valueWithCGPoint:lastPoint]];
                [self improvedErase:lastPoint];
            }
            
            CGContextAddLineToPoint(UIGraphicsGetCurrentContext(), lastPoint.x, lastPoint.y);
            
            //add the drawing point to  draw set
            if (!eraserflag) {
            }else
            {
                [erasepoints addObject:[NSValue valueWithCGPoint:lastPoint]];
                [self improvedErase:lastPoint];
            }
            
            CGContextStrokePath(UIGraphicsGetCurrentContext());
            CGContextFlush(UIGraphicsGetCurrentContext());
            
            if (eraserflag) {
                [self.templayer.image drawInRect:CGRectMake(0, 0, self.mainlayer.frame.size.width, self.mainlayer.frame.size.height) blendMode:kCGBlendModeClear alpha:0];
            } else {
                [self.templayer.image drawInRect:CGRectMake(0, 0, self.mainlayer.frame.size.width, self.mainlayer.frame.size.height) blendMode:kCGBlendModeNormal alpha:1.0];
            }
            self.templayer.image = UIGraphicsGetImageFromCurrentImageContext();
            UIGraphicsEndImageContext();
            UIGraphicsEndImageContext();
        }
    }
    UIGraphicsBeginImageContext(self.templayer.frame.size);
   
}

-(void)drawingmusic{
    
     //sound playing
     path = [[NSBundle mainBundle] pathForResource:@"chalk_stick_single_stroke_on_chalk_board_004" ofType:@"mp3"];
     if (player1.isPlaying==NO) {
     if ([[NSFileManager defaultManager] fileExistsAtPath:path])
     {
     
     NSError *errori=nil;
     player1 = [[AVAudioPlayer alloc] initWithContentsOfURL:[NSURL fileURLWithPath:path] error:&errori];
     player1.volume = 0.5f;
     [player1 prepareToPlay];
     [player1 setNumberOfLoops:0];
         if (musicisplayed) {
             [player1 play];
         }
     }
     }
}

- (IBAction)ResetButton:(id)sender {
    //Reset Image
    self.templayer.image=[UIImage imageNamed:patientImageNameforNextView];
    //Reset drawign set (both erase and interpretation)
    [patientMD removeAllObjects];
    [erasepoints removeAllObjects];
    //show notification alert
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Alert" message:@"You must select pen Button to draw again!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
    //change to default status
    eraserflag=false;
    drawingflag=false;
}

- (IBAction)changetopan:(id)sender {
    if(toggledraw){
        //if draw is enable,disable it
        toggledraw=false;
        eraserflag=false;
        drawingflag=false;
        scroller.scrollEnabled=YES;
        scroller.canCancelContentTouches=YES;
        scroller.contentSize=self.templayer.frame.size;
        scroller.userInteractionEnabled=YES;
        // Add image to button for normal state
        UIImage * btnImage1 = [UIImage imageNamed:@"Very-Basic-Hand-cursor-.png"];
        [panbutton setImage:btnImage1 forState:UIControlStateNormal];
    }
    else{
        toggledraw=true;
        drawingflag=false;
        eraserflag=false;
        scroller.scrollEnabled=NO;
        scroller.canCancelContentTouches=NO;
        self.mainlayer.userInteractionEnabled=YES;
        self.templayer.userInteractionEnabled =YES;
        scroller.userInteractionEnabled=NO;
        // Add image to button for pressed state
        UIImage * btnImage2 = [UIImage imageNamed:@"cursor-not.png"];
        [panbutton setImage:btnImage2 forState:UIControlStateNormal];
    }
    
}

- (IBAction)Musicplay:(id)sender {
    if (musicisplayed) {
        musicisplayed=false;
        [self preparToPlayMusic];
        UIImage * btnImage1 = [UIImage imageNamed:@"music_off-512.png"];
        [music setImage:btnImage1 forState:UIControlStateNormal];
    } else {
        musicisplayed=true;
        [self preparToPlayMusic];
        UIImage * btnImage1 = [UIImage imageNamed:@"music_on.png"];
        [music setImage:btnImage1 forState:UIControlStateNormal];

    }
}

-(void)preparToPlayMusic
{
    path = [[NSBundle mainBundle] pathForResource:@"tick_tock_jingle" ofType:@"mp3"];
    if ([[NSFileManager defaultManager] fileExistsAtPath:path])
    {
        
        NSError *errori=nil;
        player2 = [[AVAudioPlayer alloc] initWithContentsOfURL:[NSURL fileURLWithPath:path] error:&errori];
        player2.volume = 0.5f;
        [player2 prepareToPlay];
        [player2 setNumberOfLoops:0];
        player2.numberOfLoops=-1;
        if (musicisplayed) {
            [player2 play];
        }else
        {
            [player2 pause];
        }
    }
}


- (IBAction)erase:(id)sender {
        eraserflag=true;
        //NSLog(@"erase enable");
}

-(void)improvedErase:(CGPoint)currentpoint{
    //the remove all points where are in the thickness of eraser pen
    NSMutableArray *erasedomain=[[NSMutableArray alloc]init];
    float i=-2.5;
    float x,y;
    while (i<3) {
        float j=-2.5;
        x=currentpoint.x+i;
        while (j<3) {
            y=currentpoint.y+j;
            CGPoint temp=CGPointMake(x, y);
            [erasedomain addObject:[NSValue valueWithCGPoint:temp]];
            j=j+0.5;
        }
        i=i+0.5;
    }
    [erasedomain addObject:[NSValue valueWithCGPoint:currentpoint]];
    [patientMD removeObjectsInArray:erasedomain];
}

- (IBAction)paint:(id)sender {
    //set the drawing flag
        drawingflag=true;
        eraserflag=false;

}

- (IBAction)save:(id)sender {
        //display alert if masterneurosurgeon draw some thing
        if (patientMD.count>0) {
        NSError *error2=NULL;
            if (![_managedObjectContext save:&error2]) {
            }
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle: @"Save"
                                                       message: @"Do you want to save your interpretation as gold standard? "
                                                      delegate: self
                                             cancelButtonTitle:@"Cancel"
                                             otherButtonTitles:@"OK",nil];
        
        
            [alert show];
            }else{
                //show alert of masterneurosurgeon does not draw sth and wrongly press the save button
                UIAlertView *alertforerror=[[UIAlertView alloc]initWithTitle:@"Attention" message:@"You must draw first and then press save button" delegate:self cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
                [alertforerror show];
            }
}


-(void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (buttonIndex == 0)
    {
       // do not save the gold standard if the user press cancel
    }
    else
    {
        //read the row of current patinet case
        NSFetchRequest *request = [[NSFetchRequest alloc] init];
        [request setEntity:[NSEntityDescription entityForName:@"PatientCase" inManagedObjectContext:_managedObjectContext]];
        NSPredicate *predicate = [NSPredicate predicateWithFormat:@"patientImage like %@",patientImageNameforNextView];
        [request setPredicate:predicate];
        NSSortDescriptor *sortDescriptor = [[NSSortDescriptor alloc] initWithKey:@"patientID" ascending:YES];
        NSArray *sortDescriptors = [[NSArray alloc] initWithObjects:sortDescriptor, nil];
        [request setSortDescriptors:sortDescriptors];
        
        //update the gold standard
        NSError *error1 = nil;
        NSArray *result = [_managedObjectContext executeFetchRequest:request error:&error1];
        NSData *arrayData = [NSKeyedArchiver archivedDataWithRootObject:patientMD];
        if (result.count) {
            PatientCase* pc = [result objectAtIndex:0];
            pc.patientMD = arrayData;
            NSError *error2;
            [self.managedObjectContext save:&error2];
        }
        
        //decolor goldstandard after saving
        self.templayer.image=[UIImage imageNamed:patientImageNameforNextView];
        // to empty patientMD
        [patientMD removeAllObjects];
    }
}


#pragma mark- find points
-(float)slopeCalculator:(CGPoint)firstpoint params:(CGPoint)secondpoint
{
    float tempx=fabsf(firstpoint.x-secondpoint.x);
    float tempy=fabsf(firstpoint.y-secondpoint.y);
    if ((tempy>0) && (tempx>0))  {
        return tempy/tempx;
    }
    else{
        return 0;
    }
}
//find x and y for points between X1 and X2
-(NSMutableArray*)findpoint:(CGPoint)firstpoint param:(CGPoint)secpoint nextparam:(float)slope
{
    NSMutableArray *pointset=[[NSMutableArray alloc]init];
    
    //to exchange the value of points for keeping point with lower value in firstpoint
    if (firstpoint.x>secpoint.x) {
        CGPoint ptem=secpoint;
        secpoint=firstpoint;
        firstpoint=ptem;
    }
    float y;
    //int inty;
    float j=firstpoint.x+0.5;
    
    while (j< secpoint.x) {
        
        y=slope*j-slope*firstpoint.x+firstpoint.y;
        float fractional=y-truncf(y);
        if ((y>0) && (slope!=0)) {
            /* if (fractional>0.5) {
             inty=(int)y;
             inty++;
             CGPoint ptemp=CGPointMake(j,inty);
             [pointset addObject:[NSValue valueWithCGPoint:ptemp]];
             }*/
            /* if(fractional<0.5){
             inty=(int)y;
             CGPoint ptemp=CGPointMake(j,inty);
             [pointset addObject:[NSValue valueWithCGPoint:ptemp]];
             
             }*/
            if (fractional==0.5) {
                CGPoint ptemp=CGPointMake(j,y);
                [pointset addObject:[NSValue valueWithCGPoint:ptemp]];
            }
            if (fractional==0.0) {
                CGPoint ptemp=CGPointMake(j,y);
                [pointset addObject:[NSValue valueWithCGPoint:ptemp]];
            }
            
        }
        j=j+0.5;
    }
    return pointset;
}

-(NSMutableArray*)findpointonx:(CGPoint)firstpoint param:(CGPoint)secpoint nextparam:(float)slope
{
    NSMutableArray *pointset=[[NSMutableArray alloc]init];
    
    //to exchange the value of points for keeping point with lower value in firstpoint
    if (slope==0) {
        int tempx=firstpoint.x-secpoint.x;
        if (tempx==0) {
            //to exchange the value of points for keeping point with lower value in firstpoint
            if (firstpoint.y>secpoint.y) {
                CGPoint ptem=secpoint;
                secpoint=firstpoint;
                firstpoint=ptem;
            }
            float i=firstpoint.y+0.5;
            while (i<secpoint.y) {
                CGPoint temp=CGPointMake(firstpoint.x, i);
                [pointset addObject:[NSValue valueWithCGPoint:temp]];
                i=i+0.5;
            }
        }
    }
    return pointset;
}

-(NSMutableArray*)findpointony:(CGPoint)firstpoint param:(CGPoint)secpoint nextparam:(float)slope
{
    NSMutableArray *pointset=[[NSMutableArray alloc]init];
    
    //to exchange the value of points for keeping point with lower value in firstpoint
    if (slope==0) {
        int tempy=firstpoint.y-secpoint.y;
        if (tempy==0) {
            //to exchange the value of points for keeping point with lower value in firstpoint
            if (firstpoint.x>secpoint.x) {
                CGPoint ptem=secpoint;
                secpoint=firstpoint;
                firstpoint=ptem;
            }
            float i=firstpoint.x+0.5;
            while (i<secpoint.x) {
                CGPoint temp=CGPointMake(i, firstpoint.y);
                [pointset addObject:[NSValue valueWithCGPoint:temp]];
                i=i+0.5;
            }
        }
    }
    return pointset;
}


-(NSMutableArray*)extendedarraynew:(NSMutableArray*)param
{
    NSMutableArray *extendset=[[NSMutableArray alloc]init];
    int j=0;
    while (j+1<param.count) {
        CGPoint p1=[param[j] CGPointValue];
        j++;
        CGPoint p2=[param[j] CGPointValue];
        //j++;
        float slope=[self slopeCalculator:p1 params:p2];
        if (p1.x==p2.x) {
            [extendset addObjectsFromArray:[self findpointonx:p1 param:p2 nextparam:slope]];
        }
        if (p1.y==p2.y) {
            [extendset addObjectsFromArray:[self findpointony:p1 param:p2 nextparam:slope]];
        }
        if ((p1.x!=p2.x)&& (p1.y!=p2.y))
        {
            [extendset addObjectsFromArray:[self findpoint:p1 param:p2 nextparam:slope]];
        }
    }
    return extendset;
}



#pragma mark- scoring



-(NSMutableArray*)fillarray:(NSMutableArray*)studentinterpretation
{
    return [self extendedarraynew:studentinterpretation];
}

- (IBAction)score:(id)sender {
    
    //disable drawing and eraser flag
    eraserflag=false;
    drawingflag=false;

    
    //delete erase points from patientMD
    [patientMD removeObjectsInArray:erasepoints];
    
    //check if draw sth
    if (patientMD.count) {
        patientMD1=[self readgoldstandard];
        //lets compare points to calculate score
        // define a min variable for each member of patientMD1
        //NSLog(@"goldstandard patinetmd1 %@",patientMD1);
        NSMutableArray *set=[[NSMutableArray alloc]init];
        set=[self fillarray:patientMD1];
        //NSLog(@"goldstandard extended %@",set);
        score=0;
        for (int i = 0; i<patientMD.count; i++) {
            NSValue *val1=[patientMD objectAtIndex:i];
            CGPoint p1=[val1 CGPointValue];
            //NSLog(@"goldstandard firstloooooop %@",NSStringFromCGPoint(p1));
            NSValue *val2=[set objectAtIndex:0];
            CGPoint p2=[val2 CGPointValue];
            //NSLog(@"student firstloooooop %@",NSStringFromCGPoint(p2));
            
            //find the closest point to patinetMD1(goldStandard)
            float dx=powf((p1.x-p2.x),2);
            float dy=powf((p1.y-p2.y),2);
            float distance=sqrtf(dx+dy);
            //NSLog(@"first min %f",distance);
            float min=distance;
            for (int j=1; j<set.count; j++) {
                NSValue *val2=[set objectAtIndex:j];
                CGPoint p2=[val2 CGPointValue];
                float dx=powf((p1.x-p2.x),2);
                float dy=powf((p1.y-p2.y), 2);
                float distance=sqrtf(dx+dy);
                
                if (distance<min) {
                    min=distance;
                }
                
            }
            score=score+min;
        }
        average=score/patientMD.count;
        //NSLog(@"patientMD-meta %d", patientMD1.count);
        //NSLog(@"set %d", set.count);
        
        //NSLog(@"patientMD %d", patientMD.count);
        //NSLog(@"total deviation in points %f",score);
        //NSLog(@"average deviation in points %f",average );
        float inch=[self pointtoinch:score];
        float aveinch=[self pointtoinch:average];
        float totalmm=[self inchtomilimeter:inch];
        float avemm=[self inchtomilimeter:aveinch];
       
        //NSLog(@"total deviation in inches is %f",inch);
        //NSLog(@"average deviation in inches is %f",aveinch);
        //NSLog(@"total deviation in mm is %f",totalmm);
        //NSLog(@"average deviation in mm is %f",avemm);
        //float ave= average;
        NSString *totalptmsg =       @"\n total deviation in pt     ";
        NSString *avrptmsg =         @"\n average deviation in pt   ";
        NSString *strpoint = [NSString stringWithFormat:@"%.2f",score];
        NSString *stravr = [NSString stringWithFormat:@"%.2f",average];
        NSString *totalinchmsg =     @"\n total deviation in inches  ";
        NSString *avrichmsg =        @"\n average deviation in inches";
        NSString *strInch = [NSString stringWithFormat:@"%.2f",inch];
        NSString *straveinch = [NSString stringWithFormat:@"%.2f",aveinch];
        NSString *totalmmmsg =       @"\n total deviation in mm      ";
        NSString *avrmmmsg =         @"\n average deviation in mm    ";
        NSString *strtotalmm = [NSString stringWithFormat:@"%.2f",totalmm];
        NSString *stravemm = [NSString stringWithFormat:@"%.2f",avemm];
        NSString *Message = [totalptmsg stringByAppendingString:strpoint];
        NSString *totalpointsmsg=    @"\n total points on the line   ";
        NSString *strtotalpoints=[NSString stringWithFormat:@"%ld",patientMD.count];
        Message=[Message stringByAppendingString:avrptmsg];
        Message=[Message stringByAppendingString:stravr];
        Message=[Message stringByAppendingString:totalinchmsg];
        Message=[Message stringByAppendingString:strInch];
        Message=[Message stringByAppendingString:avrichmsg];
        Message=[Message stringByAppendingString:straveinch];
        Message=[Message stringByAppendingString:totalmmmsg];
        Message=[Message stringByAppendingString:strtotalmm];
        Message=[Message stringByAppendingString:avrmmmsg];
        Message=[Message stringByAppendingString:stravemm];
        Message=[Message stringByAppendingString:totalpointsmsg];
        Message=[Message stringByAppendingString:strtotalpoints];
        //NSString *strFromIntpoint = [NSString stringWithFormat:@"%f",average];
        //NSString *strFromIntinch = [NSString stringWithFormat:@"%f",inch];
        //NSString *final=[strFromIntpoint stringByAppendingString:strFromIntinch];
        UIAlertView *successAlert = [[UIAlertView alloc] initWithTitle:@"Your score is" message:Message delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [successAlert show];
        
    }
    else{
        UIAlertView *errorAlert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"You must draw your interpreation first and then try match" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [errorAlert show];
        
    }
    //to empty the patient dataset every time after press match
    //[patientMD removeAllObjects];
    
}


-(float)pointtoinch:(int)totaldistanceinpoint
{
    //change cgpoints into pixel
    int totaldistanceinpixel=totaldistanceinpoint*2;
    //change pixel to inches
    float totalditaceininch=totaldistanceinpixel/326.0;
    return totalditaceininch;
}


-(float)inchtomilimeter:(float)totalich{
    //1 inch==25.4 mm
    return totalich*25.4;
}
- (IBAction)match2pattern:(id)sender {
    red = 0.0/255.0;
    green = 0.0/255.0;
    blue = 255.0/255.0;
    patientMD1=[self readgoldstandard];
    //NSLog(@"goldstandard is %@",patientMD1);
    UIGraphicsBeginImageContext(self.templayer.frame.size);
    [self.templayer.image drawInRect:CGRectMake(0, 0, self.templayer.frame.size.width, self.templayer.frame.size.height)];
    CGContextSetFillColorWithColor(UIGraphicsGetCurrentContext(), [UIColor greenColor].CGColor);
    CGPoint temp;
    for (int i=0; i+1<patientMD1.count; i++) {
        temp=[[patientMD1 objectAtIndex:i]CGPointValue];
        //CGRect imageRect1 = CGRectMake(temp.x, temp.y, 1, 1);
        //CGContextFillRect(UIGraphicsGetCurrentContext(), imageRect1);
        CGContextMoveToPoint(UIGraphicsGetCurrentContext(), temp.x, temp.y);
        //next point
        if (i!=patientMD1.count) {
            i++;
            temp=[[patientMD1 objectAtIndex:i]CGPointValue];
            if (![firstpoints containsObject:[NSValue valueWithCGPoint:temp]]) {
                CGContextAddLineToPoint(UIGraphicsGetCurrentContext(), temp.x, temp.y);
            }
            
        }
        
    }
    CGContextSetRGBStrokeColor(UIGraphicsGetCurrentContext(),red, green, blue, 1);
    CGContextSetBlendMode(UIGraphicsGetCurrentContext(),kCGBlendModeNormal);
    CGContextStrokePath(UIGraphicsGetCurrentContext());
    self.templayer.image = UIGraphicsGetImageFromCurrentImageContext();
    //NSLog(@"compare pattern");
    
}





-(NSMutableArray*)readgoldstandard
{
    NSEntityDescription *entitydescription=[NSEntityDescription entityForName:@"PatientCase" inManagedObjectContext:_managedObjectContext];
    NSFetchRequest *request=[[NSFetchRequest alloc]init];
    [request setEntity:entitydescription];
    
    // read gols standard of current patinet iamge
    NSPredicate *perdicate=[NSPredicate predicateWithFormat:@"patientImage like %@",patientImageNameforNextView];
    [request setPredicate:perdicate];
    
    NSError *error1=NULL;
    NSArray *matchdata=[_managedObjectContext executeFetchRequest:request error:&error1];
    NSString *patientID1;
    NSString *patientImage1;
    
    for (NSManagedObject *obj in matchdata) {
        patientID1=[obj valueForKey:@"patientID"];
        patientImage1=[obj valueForKey:@"patientImage"];
        patientMD1 = [NSKeyedUnarchiver unarchiveObjectWithData:[obj valueForKey:@"patientMD"]];
    }
    return patientMD1;
}



@end
